#!/usr/bin/env python
# -*- coding: utf-8 -*-

# ----------------------------------------------------------------------------
# pyjama - python jamendo audioplayer
# Copyright (c) 2008 Daniel Nögel
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# ----------------------------------------------------------------------------

# This Script was found on:
# http://www.valuedlessons.com/2008/04/events-in-python.html

x = False

class EventHandler:
    def __init__(self):
        self.handlers = [] #set()

    def handle(self, handler):
        #self.handlers.insert(0,handler)
        self.handlers.append(handler)
        return self

    def unhandle(self, handler):
        try:
            self.handlers.remove(handler)
        except:
            raise ValueError("Handler is not handling this event, so cannot unhandle it.")
        return self

    def fire(self, *args, **kargs):
        for handler in self.handlers:
#            if "alldone" in str(handler): print handler
            handler(*args, **kargs)

    def getHandlerCount(self):
        return len(self.handlers)

    __iadd__ = handle
    __isub__ = unhandle
    __call__ = fire
    __len__  = getHandlerCount
    
class Events:
    def __init__(self):
#        self.pluginloaded = EventHandler()
#        self.nowplaying = EventHandler()
#        self.alldone = EventHandler()
        self.dict = {}

    def add_event(self, eventname):
        self.dict[eventname] = EventHandler()

    def connect_event(self, eventname, fkt):
        self.dict[eventname] += fkt

    def disconnect_event(self, eventname, fkt):
        self.dict[eventname] -= fkt

    def raise_event(self, eventname, *argv, **kargs):
        self.dict[eventname](*argv, **kargs)

