#!/usr/bin/env python
# -*- coding: utf-8 -*-

# ----------------------------------------------------------------------------
# pyjama - python jamendo audioplayer
# Copyright (c) 2008 Daniel Nögel
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# ----------------------------------------------------------------------------

import gtk

class Layouts():
    def __init__(self, pyjama):
        self.pyjama = pyjama
        self.layouts = {}
        self.toolbars = {}
        self.current_layout = None

        self.pyjama.Events.add_event("show_layout")

    def register_layout(self, layout_name, layout_class):
        self.layouts[layout_name] = layout_class
        self.toolbars[layout_name] = layout_class.ToolBar(self.pyjama)
        self.pyjama.window.vbTop.pack_end(self.toolbars[layout_name], True, True)        

    def show_layout(self, layout, data1=None, data2=None, data3=None, data4=None, fromhistory=False, who_called=None):
        # hiding the last layout's toolbar
        if self.current_layout != None and layout != self.current_layout:
            self.toolbars[self.current_layout].hide()
        
    
        #
        # History
        #
        if self.pyjama.historyCurrent != {} and fromhistory==False:
            self.pyjama.historyBack.append(self.pyjama.historyCurrent)
        if fromhistory == False:
            pass
            # need to do this
        self.pyjama.historyCurrent = {'layout':layout, 'data1':data1, 'data2':data2, 'data3':data3, 'data4':data4}
        self.pyjama.window.toolbar.bHistoryForward.set_sensitive(len(self.pyjama.historyForward)>0)
        self.pyjama.window.toolbar.bHistoryBack.set_sensitive(len(self.pyjama.historyBack)>0)
        
        #
        # insert Layout into scrolledwindow
        #        
        if self.current_layout != None:
            self.pyjama.window.scrolledwindow.remove(self.pyjama.window.scrolledwindow.child)
            # For non-scrollable widgets - no scrollbars for some reasons
            # self.pyjama.window.scrolledwindow.add_with_viewport(self.layouts[layout])
        self.pyjama.window.scrolledwindow.add(self.layouts[layout])
        # Setting Scrollbars
        self.pyjama.window.scrolledwindow.set_vadjustment(gtk.Adjustment(value=0, lower=0, upper=0, step_incr=0, page_incr=0, page_size=0))

        self.current_layout = layout
        
        # showing the toolbar
        self.toolbars[layout].show()
        # calling the layout's draw method:,
        self.layouts[layout].draw(data1, data2, data3, data4)
