#!/usr/bin/env python
# -*- coding: utf-8 -*-

# ----------------------------------------------------------------------------
# pyjama - python jamendo audioplayer
# Copyright (c) 2008 Daniel Nögel
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# ----------------------------------------------------------------------------

# This Script was inspired by:
# http://pytute.blogspot.com/2007/04/python-plugin-system.html

import os
import sys
import imp
#import clEvent
import traceback

class Plugins():
    def __init__(self, pyjama):
        self.pyjama = pyjama
        self.loaded = {}
        self.pluginpath = os.path.join(os.path.dirname(imp.find_module("pyjama")[1]), "plugins/")
        print "Found Plugins in folder: ", self.pluginpath
        self.pluginfiles = [fname[:-3] for fname in sorted(os.listdir(self.pluginpath)) if fname.endswith(".py")]

        # THIS LINE INSERTS THE PLUGINPATH AS
        # FIRST PATH IN PATHS
        # SINCE I CAN NOT IMPORT FROM FILENAMES
        # THIS SEEMS TO BE THE BEST SOLUTION
        sys.path.insert(0, self.pluginpath[:-1])

#    def do_import(self):
        self.imported_modules = []
#        if not self.pluginpath in sys.path:
#            sys.path.append(self.pluginpath)
        for fname in self.pluginfiles:
            if not fname+"-" in sys.argv and not fname in self.pyjama.settings.get_value("PLUGINS", 'blacklist') or fname+"+" in sys.argv:
                try:
                    mod = __import__ (fname)
#                    if not self.pluginpath in mod.__file__:
#                        print "Error"
                    self.imported_modules.append(mod)
                except Exception:
                    print traceback.format_exc()
                    print "Error importing Plugin %s" % fname
            else:
                print "Plugin %s ignored" % fname
#            self.imported_modules = [__import__(fname) for fname in self.pluginfiles]
        #[mod.register() for mod in imported_modules]
        ev = self.pyjama.Events
        for mod in self.imported_modules:
#            try:
            name = mod.__name__
            try:
                self.loaded[name] = mod.main(self.pyjama)
                ev.raise_event('pluginloaded', name)
            except:
                print traceback.format_exc()
                print "Error loading Plugin %s" % name
                print mod.__file__

#            except AttributeError:
#                print "Error importing plugin '%s'" % name
#                print "You need to have a class 'main' in it, which can be called by pyjama"
#            except TypeError:
#                print "Init-function of '%s' needs to take two params" % name

#x = Plugins()
#x.plugins['test2'].test()
