#!/usr/bin/env python
# -*- coding: utf-8 -*-

# ----------------------------------------------------------------------------
# pyjama - python jamendo audioplayer
# Copyright (c) 2008 Daniel Nögel
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# ----------------------------------------------------------------------------

import urllib
import md5
import os

import threading
import clSettings
import functions

# Gettext - Übersetzung
functions.translation_gettext()
#def _(string):
#    return string

settings = clSettings.settings()

class Download( threading.Thread ):
    def __init__( self, parent, url, num):
        self.url = url
        self.parent = parent
        self.num = num
        threading.Thread.__init__(self)
  
    ###################################################################
    #
    # get a album's cover
    # RETURNS: None = error
    #
    def run( self ):
        md5hash = md5.new(self.url).hexdigest()
        imagepath = os.path.join(self.parent.home, "images", md5hash)
        if not os.path.exists(imagepath):
            if self.parent.debug:
                print ("[%i] Trying to burst-download cover for %s[...]") % (self.num, self.url)
            try:
                urllib.urlretrieve(self.url, imagepath)
                return "0"
                if self.parent.debug:
                    print ("[%i] Burst-downloaded Cover from Jamendo") % self.num
            except IOError:
                print ("[%i] Could not get album cover from jamendo") % self.num
                return "1"
        else:
            return "0"
            if self.parent.debug:
                print ("[%i] Not Burst-Downloading: Cover on HD") % self.num

###################################################################
#
# test if to much threads a running at the same time
# RETURNS: True = to much threads, False = less than MAX_THREADS
#
def threadLimiter(threads):
    counter = 0
    for thread in threads:
        if threads[thread].isAlive():
            counter += 1
        if counter > settings.get_value("PERFORMANCE", "MAX_THREADS"):
            return True
    return False
