#!/usr/bin/env python
# -*- coding: utf-8 -*-

# ----------------------------------------------------------------------------
# pyjama - python jamendo audioplayer
# Copyright (c) 2008 Daniel Nögel
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# ----------------------------------------------------------------------------

import sys,os
#import pygtk
#pygtk.require("2.0")

import os, sys
sys.path.append("..")
#if os.name == "posix":
#    sys.path.append("/usr/share/apps/pyjama") # linux
#else:
#    sys.path.append(os.path.join(os.getenv('PROGRAMFILES'), "pyjama")) # windows

import gtk
import gtk.glade
import gobject

import re

try:
    import gtkhtml2
#    lib = "gtkhtml"
except ImportError:
    print "PMC need gtkhtml2 installed (python-gtkhtml2)"
    raise ImportError, 'gtkhtml2'
#    import mozembed
#    lib = "moz"
import urllib2
import functions
import clWidgets

firstrun_message = _("""
<div class = "headline">Welcome to Pyjama!</div><br />
<br />This is the first time you run Pyjama. Pyjama is a Audioplayer for Jamendo's free music archive. Right now, you can find _ARTISTS_ artists, _ALBUMS_ albums and _TRACKS_ tracks on Jamendo and Pyjama will help you, to experience this free music as easy as possible.<br />
Some features are:
<ul>
    <li>browsing albums by various critera</li>
    <li>creating and saving playlists</li>
    <li>stay in touch with the jamendo community with the mozplug-browser-plugin</li>
<ul>
I hope, you will like Pyjama and enjoy your tour through jamendo with it. Please let me now, if you have any issues using Pyjama.<br />
<strong>This window will open on startup and only, when new news are available.</strong> <br /><br /><br />
""")

class main():
    def __init__(self, pyjama):
        self.pyjama = pyjama

        self.pyjama.Events.connect_event("alldone", self.ev_alldone)
        self.pyjama.Events.connect_event("firstrun", self.ev_firstrun)

        self.html_code = None
        self.firstrun = False

        curdir = os.path.abspath(os.path.curdir)
        curdir = os.path.join(curdir, "plugins", "PMC")
        self.gladefile = os.path.join(functions.install_dir(), "plugins" , "PMC", "pmc.glade")
        try:
            self.wTree = gtk.glade.XML(self.gladefile)  
        except RuntimeError:
            print "Error loading glade file"
            print "tried to load it from: ", self.gladefile
        self.window = self.wTree.get_widget("window1")
        self.window.set_title("PMC - Pyjama Message Center")#(self.__class__.__name__)
        self.window.set_icon_from_file(os.path.join(functions.install_dir(), "images", "pyjama.png"))
#        self.window.set_skip_taskbar_hint(True)#(not self.main.settings['show_window_in_taskbar'])
        self.scrolledwindow = self.wTree.get_widget("scrolledwindow1")
        self.bClose = self.wTree.get_widget("bClose")
        self.bUpdate = self.wTree.get_widget("bUpdate")
        self.bBug = self.wTree.get_widget("bBug")
        self.bFeedback = self.wTree.get_widget("bFeedback")

#        self.curpage = "file://" + os.path.join(curdir, "pmc.html")
        self.curpage = "http://xn--ngel-5qa.de/pmc.html"

        self.bClose.connect("clicked", self.on_close)
        self.bBug.connect("clicked", self.on_bug)
        self.bUpdate.connect("clicked", self.on_update)
        self.bFeedback.connect("clicked", self.on_feedback)

        htmlview = gtkhtml2.View()
        htmlview.show()
        htmlview.connect('on_url', self.on_url)

        self.document = gtkhtml2.Document()
        self.document.connect('request_url', self.request_url)
        self.document.connect('link_clicked', self.link_clicked)
        self.document.connect('submit', self.submit)
        self.document.clear()

        htmlview.set_document(self.document)
        self.scrolledwindow.set_property("hscrollbar-policy", gtk.POLICY_AUTOMATIC)
        self.scrolledwindow.set_property("vscrollbar-policy", gtk.POLICY_AUTOMATIC)
        self.scrolledwindow.add(htmlview)

        # Dirty, will have a look at this later:
        # pmc only is allowed to get data from the web 
        # when the user can see the gui


    def ev_firstrun(self):
        self.firstrun = True

    def ev_alldone(self):
        print "Checking for PMC news"
        self.html_code = self.get_content(self.curpage)
        if self.html_code == None:
            print "An error occured: will not load PMC"
            return
        print "done"

        curver = self.read_tag(self.html_code, "version") # current version of pyjama
        release = self.read_tag(self.html_code, "release") # id of pmc-new
        localver = self.pyjama.version
        self.html_code = self.html_code.replace("LOCALVERSION", localver)

#        firstrun = self.pyjama.settings.get_value("PYJAMA", "first_run", True)
        if self.firstrun  == True:
            self.html_code = self.html_code.replace("<!-- FIRSTRUN -->", firstrun_message)
            self.html_code = self.html_code.replace("_ARTISTS_", str(self.pyjama.db.artists))
            self.html_code = self.html_code.replace("_ALBUMS_", str(self.pyjama.db.albums))
            self.html_code = self.html_code.replace("_TRACKS_", str(self.pyjama.db.tracks))
            self.window.show()

        self.show_page(self.html_code)

        if not "noupdate" in sys.argv:
            if not self.pyjama.settings.option_exists("PMC", "release"):
                self.pyjama.settings.set_value("PMC", "RELEASE", release)
                self.window.show()
            elif int(self.pyjama.settings.get_value("PMC", 'release', 0)) < int(release):
                self.pyjama.settings.set_value("PMC", "RELEASE", release)
                self.window.show()
            elif not self.firstrun:
                self.window.hide()

        if curver > localver:
            self.bUpdate.show()
        else:
            self.bUpdate.hide()


        # add button to toolbar
        toolbar = self.pyjama.window.toolbar
        self.bPMC = gtk.ToolButton("PMC")
        toolbar.set_image(self.bPMC, os.path.join(functions.install_dir(), "plugins", "PMC", "pmc.png"))
        self.bPMC.set_tooltip_text(_("Show PMC"))
        self.bPMC.set_label("PMC")
        self.bPMC.connect("clicked", self.on_PMC_clicked)
        try:
            pos = toolbar.get_item_index(toolbar.space_fs)
        except:
            pos = -2
        toolbar.insert(self.bPMC, pos+1)
        self.bPMC.show()

    def on_feedback(self, ev):
        self.pyjama.Events.raise_event("open_url","http://www.xn--ngel-5qa.de/pyjama/component/controller,dashboard/task,add/option,com_easygb/Itemid,46/", force_default=True)

    def on_PMC_clicked(self, ev):
#        self.load_pmc()
        self.window.show()

    def read_tag(self, text, tag):
        # this is kind of ugly, but i did not like the regex....
        start = "<%s>" %tag
        end = "</%s>" %tag
        start_pos = text.find(start) + len(start)
        end_pos = text.find(end)
        return text[start_pos:end_pos].strip()

    def on_bug(self, ev):
        self.pyjama.Events.raise_event("open_url","https://bugs.launchpad.net/pyjama", force_default=True)

    def on_close(self, ev):
        self.window.hide()

    def on_update(self, ev):
            self.pyjama.Events.raise_event("open_url","https://launchpad.net/pyjama/+download", force_default=True)

    def show_page(self, html):
        self.document.open_stream("text/html") # this is the only mime type recognized
        self.document.write_stream(html)
        self.document.close_stream()

    def get_content(self, url):
        try:
            content = urllib2.urlopen(url)
        except urllib2.URLError:
            print ("Error reading %s" %url)
            return None

        content = content.read()
        return content

    def link_clicked(self, document, link):
        self.pyjama.Events.raise_event("open_url",link, force_default=True)

    def submit(self, document, action, method, var):
        self.pyjama.Events.raise_event("open_url",action, force_default=True)

    # requesturl receives the document, URL and a stream to write the data to. 
    # You should just fetch the data from the URL and write it to the stream.
    def request_url(self, document, link, stream):
        content = self.get_content(link)
        stream.write(content)
        stream.close()
#        fh = open(link, "r")
#        if fh:
#            content = fh.read()
#            stream.write(content)
#            stream.close()
#        else:
#            print "Error"

    # on_url receives the htmlview object and the url.
    def on_url(self, document, link):
      #link = link.strip()
      #gnome.url_show(link)
        pass
        #print link

if __name__ == "__main__":
    print "running on its own"
    run = main()
    gtk.main()

