#!/usr/bin/env python
# -*- coding: utf-8 -*-

# ----------------------------------------------------------------------------
# pyjama - python jamendo audioplayer
# Copyright (c) 2008 Daniel Nögel
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# ----------------------------------------------------------------------------

import traceback

import gtk, gtk.glade
import os

import functions

class main():
    def __init__(self, pyjama):
        self.pyjama = pyjama

        #self.pyjama.error_fkt = self.ev_error
        self.pyjama.Events.connect_event("error", self.ev_error)

        self.install_dir = functions.install_dir()

        gladefile = os.path.join(self.install_dir, "plugins" , "catchERR", "catchERR.glade")
        try:
            self.wTree = gtk.glade.XML(gladefile)  
        except RuntimeError:
            print "Error loading glade file"
            print "tried to load it from: ", gladefile

        self.dialog = self.wTree.get_widget("error_dialog")
        self.bOK = self.wTree.get_widget("bOK")
        self.label_title = self.wTree.get_widget("label3")
        self.expander = self.wTree.get_widget("expander1")
        textview = self.wTree.get_widget("textview1")
        self.textbuffer = gtk.TextBuffer()   
        textview.set_buffer(self.textbuffer)

        self.bOK.show()
        self.label_title.show()
        self.expander.show()
        textview.show()

        self.dialog.set_title("An Error occured")

        self.dialog.connect('delete_event', self.quit)
        self.bOK.connect('clicked', self.quit)

        self.dialog.set_icon_from_file(os.path.join(functions.install_dir(), "images", "pyjama.png"))
    


    def quit(self, ev, ev2=None):
        self.dialog.hide()

    def show(self):
        self.dialog.show()

    def ev_error(self, error_inst=None, desc=False):
            tb =  traceback.format_exc()
            if tb.strip() == "None":
                self.expander.hide() 
#                if error_inst == None:
#                    self.expander.hide() 
#                else:
#                    tb = error_inst
            else: 
                self.expander.show()
            if not desc: 
                desc = error_inst
                self.expander.hide()
            print "An error occured: %s" % error_inst
            self.label_title.set_markup(str(desc))
            self.textbuffer.set_text(tb)
            self.show()
            if 1 == 2:
                print "-"*60
                print tb
                print "-"*60
