#!/usr/bin/env python

# example plugin

# every folder containing a file named "FOLDERNAME.info"
# will be recogniced as a plugin.
# Furthermore the folder needs to contain a file "__init__.py"
# which holds a class named "main".
# When loading a plugin pyjama will pass the object "pyjama"
# which holds all the other objects.

class main():
    def __init__(self, pyjama):
        # Pyjama's Class main:
    	self.pyjama = pyjama

        # you cannot directly access the plugins
        # object of pyjama in your init function
        # since it is created after all plugins
        # have been initaliced.
        # Following line will fail:
        # plugins = self.pyjama.plugins <-- ERROR
        
        # connect to the "alldone" event, if you
        # want pyjama to call your plugin after
        # everythin else is done!

        self.Events = self.pyjama.Events
        self.Events.connect_event("alldone", self.ev_alldone)

        # You can diconnect fom events, but not
        # when the function, which disconnects from
        # the event was called by the event you want
        # to disconnect from.
        # This might be a bigger issue...
        #self.Events.disconnect_event("alldone", self.ev_alldone)       

    def ev_alldone(self):
        # this function will be called after pyjama
        # has been loaded.
        # Now you can access any other plugins...
        
        if "nowplaying" in self.pyjama.plugins.loaded:
            # print "Plugin 'nowplaying' can be found!'
            pass 
        
